/**
  Copyright 2002 Bruce Spencer 
*/

/**
   <code>ParserBasic</code> contains constants used by the parser

   @author Bruce Spencer <bspencer@unb.ca>
   @version
   
   Created: Tue Sep 19 13:02:28 2000
*/
class ParserBasic{
  static final String LEFTPAREN = "(";
  static final String RIGHTPAREN = ")";
  static final String LEFTBRACKET = "[";
  static final String RIGHTBRACKET = "]";
  static final String PERIOD = ".";
  static final String COMMA = ",";
  static final String PERCENT = "%";
  static final String PLUS = "+";
  static final String MINUS = "-";
  static final String TAB = "\t";
  static final String SPACE = " ";
  static final String LESS = "<";
  static final String GREATER = ">";
  static final String COLON = ":";
  static final String WHITE = TAB + SPACE;
  static final String SINGLE_QUOTE = "'";
  static final String DELIMITERS = 
    LEFTPAREN + RIGHTPAREN + LEFTBRACKET + 
    RIGHTBRACKET + PERIOD + COMMA + PERCENT + PLUS + MINUS + 
    TAB + SPACE + LESS + GREATER + COLON + SINGLE_QUOTE;
  static final String ESCAPE = "\\";

  /**
     <code>delimiter</code> returns true if the String argument
     given is a delimiter.

     @param s - a <code>String</code> value
     @return a <code>boolean</code> value */
  public static boolean delimiter(String s){
    return s.length() == 1 & 
      DELIMITERS.indexOf(s.charAt(0))>=0;
  }

  /**
     <code>containsDelimiters</code> returns true if s

     @param s - a <code>String</code> value
     @return a <code>boolean</code> value
  */
  public static boolean containsDelimiters(String s){
    for(int i = 0; i < s.length(); i++)
      if (DELIMITERS.indexOf(s.charAt(i))>=0) 
	return true;
    return false;
  }

}



