/* Copyright (c) 2002 Bruce Spencer, National Research Council, Canada */
import java.io.*;
import java.util.*;

/**
   Describe class <code>BUDCTree</code> here.

   @author Bruce Spencer <Bruce.Spencer@nrc.ca>
   @version 
*/
public class TestDiscIterator{

  static SymbolTable symbolTable = new SymbolTable();
  static DiscTree oldFactDiscTree = new DiscTree(symbolTable);
  static DiscTree ruleDiscTree = new DiscTree(symbolTable);
  static Heap newFactHeap = new Heap();

  static final boolean TRACE = true;

  public static void main(String args[]){


    DCFileParser dcfp = new DCFileParser(symbolTable);

    dcfp.parseDCFile("examples.dc");

    Iterator it = dcfp.iterator();
    while(it.hasNext()){
      DefiniteClause dc = (DefiniteClause) it.next();
      if(dc.symbols.length == dc.symbols[0][1]){
  	//then this definite clause is a fact
  	//so put it in with the facts
  	newFactHeap.add(dc);
      }
      else{
  	//else it is a new rule
  	ruleDiscTree.insert(dc, 1);
      }
    }
    
    if(TRACE){
      System.out.println("Old Facts:\n" + oldFactDiscTree + "\n");
      System.out.println("Rules:\n" + ruleDiscTree + "\n");
      System.out.println("New Facts:" + newFactHeap + "\n");
    }

    System.out.println("Discrimination Tree oldFacts");
    Iterator lit = oldFactDiscTree.allLeavesIterator();
    int j = 0;
    while(lit.hasNext()){
      j++;
      System.out.println(j+": " + ((DefiniteClause) lit.next()) );
    }
    

    System.out.println("Discrimination Tree Rules");
    Iterator lit2 = ruleDiscTree.allLeavesIterator();
    int k = 0;
    while(lit2.hasNext()){
      k++;
      System.out.println(k+": " + ((DefiniteClause) lit2.next()) );
    }
  }

}
