/* Copyright (c) 2002 Bruce Spencer, National Research Council, Canada */
import java.io.*;
import java.util.*;

/**
   Describe class <code>BUDCTree</code> here.

   @author Bruce Spencer <Bruce.Spencer@nrc.ca>
   @version 
*/
public class TestSubsume {

  static SymbolTable symbolTable = new SymbolTable();
  static DiscTree oldFactDiscTree = new DiscTree(symbolTable);
  static DiscTree newRuleDiscTree = new DiscTree(symbolTable);
  static Heap newFactHeap = new Heap();

  public static void main(String args[]){


    DCFileParser dcfp = new DCFileParser(symbolTable);

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    while(true){
      try{
	System.out.println("Enter clause C");
	DefiniteClause c = dcfp.parseDefiniteClause
	  (br.readLine() + ".");
	System.out.println("Enter clause D");
	DefiniteClause d = dcfp.parseDefiniteClause
	  (br.readLine() + ".");
	if (factSubsumes(c, d)){
	  System.out.println("C subsumes D");
	}
	else {
	  System.out.println("C does not subsume D");
	}
      }
      catch (ParseException e){
	e.printStackTrace();
      }
      catch (IOException e){
	e.printStackTrace();
      }
    }
  }

  static boolean factSubsumes(DefiniteClause c1, DefiniteClause c2){
    Unifier u1 = new Unifier(c2, Unifier.GROUNDING_MODE);
    if(u1.unified){
      Unifier u2 = new Unifier(c1,0,0,u1,Unifier.ONEWAY_MODE);
      return u2.unified;
    }
    return false;
  }
}

